
#define	LOCKTIME	0x4c000000
#define UPLLCON		0x4c000008
#define MPLLCON		0x4c000004
#define CLKDIVN		0x4c000014
#define CAMDIVN		0x4c000018
	
#define UPLLVAL		((60<<12)|(4<<4)|1)
#define MPLLVAL		((0x6e<<12)|(3<<4)|1)

.global clksetup
	
clksetup:
	ldr	r0, =LOCKTIME
	mov	r1, #0xffffffff
	str	r1, [r0]
	
	ldr	r0, =CAMDIVN
	mov	r1, #0
	str	r1, [r0]

	/*
	 * PCLK = HCLK/2, HCLK = FCLK/4, UCLK = UPLL/2 (96MHz)
	 */
	ldr	r0, =CLKDIVN
	mov	r1, #0xd
	str	r1, [r0]

	/*
	 * 15 μ ͼ CPU 带
	 * asynchrononous   ϴ ̴.
	 */
	mrc	p15, 0, r1, c1, c0, 0
	orr	r1, r1, #0xc0000000
	mcr	p15, 0, r1, c1, c0, 0

	/*
	 * MPLL 399.65MHz, UPLL 95.96MHz Ѵ.
	 * www.emlinux.co.kr  533MHz Ҽ  
	 * ϴ  Ҿؼ 400MHzθ Ѵ. ( 尡 μ..)
	 */
	ldr	r0, =UPLLCON
	ldr	r1, =UPLLVAL
	str	r1, [r0]
	
	ldr	r0, =MPLLCON
	ldr	r1, =MPLLVAL
	str	r1, [r0]
	
	mov	pc, lr