	
#define GPFCON		0x56000050
#define GPFDAT		0x56000054
#define GPFUP		0x56000058		

#define WAIT_TIME	0xf00
	
.text

.global	_led_init
.global _led_on
.global _led_off
.global _led_wait_time		

_led_init:
	ldr	r5, =GPFCON	@ LED 1~4 Input mode
	ldr	r1, [r5]
	and	r1, r1, #(~(0xFF<<8))
	orr	r1, r1, #(0x55<<8)
	str	r1, [r5]

	ldr	r5, =GPFUP	@ pull up register disable
	ldr	r1, [r5]
	orr	r1, r1, #(0xF<<4)
	str	r1, [r5]

	mov	pc, lr

_led_off:			
	ldr	r5, =GPFDAT	@ LED 1~4 Init (LED off)
	ldr	r1, [r5]
	orr	r1, r1, #(0xF<<4)
	str	r1, [r5]

	ldr	r5, =GPFDAT
	ldr	r1, [r5]

	mov	pc, lr

_led_on:
	ldr	r5, =GPFDAT
	ldr	r4, [r5]				
	bic	r4, r4, r0
	str	r4, [r5]

	mov	pc, lr

_led_wait_time:
	mov	r2, #WAIT_TIME
wait:	
	nop
	nop
	
	subs	r2, r2, #1
	bne	wait

	mov	pc, lr
