
#define KERNEL_RAM_BASE	0x30100000	@ Ŀ RAM εǴ ּ
#define KERNEL_ROM_BASE	0x10000		@ Ŀ ϰ ִ NOR ּ
#define KERNEL_ROM_END	0x9ffff		@ Ŀ ϰ ִ NOR  ּ

#define vector_UNDEF	0x30100004
#define vector_SWI	0x30100008
#define vector_PABORT	0x3010000c
#define vector_DABORT	0x30100010
#define vector_RESERV	0x30100014
#define vector_INTREQ	0x30100018
#define vector_FINTREQ	0x3010001c
	
#define WTCON		0x53000000

		
.text

.global	_start
	
_start:	b	RESET		@ offset 0x00 :	Reset
	b	UNDEF		@ offset 0x04 :	Undefined Instruction
	b	SWI		@ offset 0x08 :	Software Instruction
	b	PABORT		@ offset 0x0c :	Prefetch Abort
	b	DABORT		@ offset 0x10 :	Data Abort
	b	RESERV		@ offset 0x14 :	reserved
	b	INTREQ		@ offset 0x18 :	Interrupt Request
	b	FINTREQ		@ offset 0x1c :	Fast Interrupt Request

RESET:
	/*
	 *   led õ GPIO ʱȭ
	 */
	bl	_led_init
	bl	_led_off

	mov	r0, #0x10
	bl	_led_on
	
	/*
	 * CPU SVC32 mode ȯϰ Interrupt, Fast Interrupt disable Ѵ
	 * 2440   60 ͷƮ ϴµ CPU cpsr I, F 0
	 * clearǰ, INTMSK 0 setǾ߸ ͷƮ ߻ϹǷ ϰ 
	 * cpsr I, F ؼ ͷƮ Ȱȭ ߴ
	 * u-boot start.S  INTMSK, INTSUBMSK  clear ־µ
	 *  ׷ ؾ߸ ϴ    𸣰ڴ.   ص ǰ
	 * ׳ ó ϴ°  Ѱ ..
	 */
	mrs	r0, cpsr
	bic	r0, r0, #0x2c
	orr	r0, r0, #0xc3
	msr	cpsr, r0

	/*
	 * Watchdog Timer Ȱȭ Ų
	 * ý   ڵ resetǴ ε ϴµ ȥ 
	 * ټ Ƿ Ȱȭ Ѵ
	 */
	ldr	r0, =WTCON
	ldr	r1, [r0]
	mov	r1, #0
	str	r1, [r0]

	/*
	 * FCLK, HCLK, PCLK, UCLK CPU ֺ  ޵Ǵ clock
	 * ӵ Ѵ.
	 * # ƴ. Ȯϰ ذ ȵȴ. 켱 u-boot ҽ  .
	 */
	bl	clksetup

	mov	r0, #0x20
	bl	_led_on
		
	/*
	 * ޸ Ʈѷ ʱȭ κ̴.
	 * #  κп ƴ. 켱 u-boot ҽ 
	 */
	bl	memsetup	

	mov	r0, #0x40
	bl	_led_on
	
	/*
	 * kernel nor ram ű. ѽ~ ų.
	 * _OS_RAM_BASE = 0x30100000
	 *
	 *
	 * |                  |
	 * |                  |
	 * |   RAM REGION     |
	 * |__________________|  <- r1
	 * |                  |
	 * |                  |
	 * |                  |
	 * |__________________|  <- r2
	 * |                  |
	 * | ROM(NOR) REGION  | 
	 * |__________________|  <- r0
	 */
osload:	
	ldr	r0, _KERNEL_ROM_BASE
	ldr	r1, _KERNEL_RAM_BASE
	ldr	r2, _KERNEL_ROM_END
	
copy_loop:
	ldmia	r0!, {r3-r7}
	stmia	r1!, {r3-r7}
	cmp	r0, r2
	blt	copy_loop

	mov	r0, #0x40
	bl	_led_on
	
	/*
	 *  kernel .
	 * Ϸ绡 C Ѿ ڴ..
	 * head.S -> _start .
	 */
	ldr	pc, _KERNEL_RAM_BASE

	.balign 4

	
		
_KERNEL_ROM_BASE:
	.word KERNEL_ROM_BASE

_KERNEL_RAM_BASE:	
	.word KERNEL_RAM_BASE
	
_KERNEL_ROM_END:	
	.word KERNEL_ROM_END


	
/*
 * expection vector table
 */
UNDEF:	
	ldr	pc, =vector_UNDEF
	
SWI:	
	ldr	pc, =vector_SWI
	
PABORT:	
	ldr	pc, =vector_PABORT
	
DABORT:	
	ldr	pc, =vector_DABORT

RESERV:	
	ldr	pc, =vector_RESERV

INTREQ:	
	ldr	pc, =vector_INTREQ
	
FINTREQ:
	ldr	pc, =vector_FINTREQ